if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Online]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Online]
GO

CREATE TABLE [dbo].[Online] (
	[Id] [int] NULL 
) ON [PRIMARY]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clearonlinerecords]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[clearonlinerecords]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE  PROCEDURE  clearonlinerecords 
@zoneid             integer,
@aid                   integer

AS
SET NOCOUNT ON
SET ANSI_NULLS ON
SET ANSI_WARNINGS ON
SET ANSI_NULL_DFLT_ON ON
SET QUOTED_IDENTIFIER ON

	BEGIN TRAN
	UPDATE point SET zoneid = NULL, zonelocalid = NULL WHERE aid = @aid AND zoneid = @zoneid
	DELETE Online
	COMMIT TRAN
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[recordoffline]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[recordoffline]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE  PROCEDURE  recordoffline 

@uid                   integer,
@aid                   integer,
@zoneid              integer out,
@zonelocalid       integer out,
@overwrite          integer out

AS

SET NOCOUNT ON
SET ANSI_NULLS ON
SET ANSI_WARNINGS ON
SET ANSI_NULL_DFLT_ON ON
SET QUOTED_IDENTIFIER ON

	BEGIN TRAN
	UPDATE point SET zoneid = NULL, zonelocalid = NULL WHERE uid = @uid AND aid = @aid AND zoneid = @zoneid
	SELECT @overwrite = @@rowcount
	IF @overwrite = 0 SELECT @zoneid = zoneid, @zonelocalid = zonelocalid FROM point WHERE uid = @uid AND aid = @aid

	DELETE Online WHERE Id=@uid 
	COMMIT TRAN
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[recordonline]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[recordonline]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


CREATE  PROCEDURE  recordonline 

@uid                   integer,
@aid                   integer,
@zoneid              integer out,
@zonelocalid       integer out,
@overwrite          integer out

AS

SET NOCOUNT ON
SET ANSI_NULLS ON
SET ANSI_WARNINGS ON
SET ANSI_NULL_DFLT_ON ON
SET QUOTED_IDENTIFIER ON

	BEGIN TRAN
	DECLARE @tmp_zoneid      integer
	DECLARE @tmp_zonelocalid integer
	SELECT @tmp_zoneid = zoneid, @tmp_zonelocalid = zonelocalid FROM point WHERE uid = @uid AND aid = @aid
	IF @@rowcount = 0
		INSERT INTO point (uid,aid,time,zoneid,zonelocalid,lastlogin) VALUES (@uid,@aid,0,@zoneid,@zonelocalid,getdate())
	ELSE IF @tmp_zoneid = NULL OR @overwrite = 1
		UPDATE point SET zoneid = @zoneid, zonelocalid = @zonelocalid, lastlogin = getdate() WHERE uid = @uid AND aid = @aid
	IF @tmp_zoneid = NULL
		SELECT @overwrite = 1
	ELSE
		SELECT @zoneid = @tmp_zoneid, @zonelocalid = @tmp_zonelocalid
	INSERT INTO Online (Id) VALUES(@uid)
	COMMIT TRAN
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO